function imgOut = LinPredHorizPdim(I,mask,p)
% Metodo il quale, data un'image in ingresso, predice (solo) la zona selezionata
% dalla maschera.
% Predizione ORIZZONTALE.
%
% X X X O
%           pi
% O X X X
%
% I = input intensity image
% p = predictor order
% img = output image
% Uses 1st-order optimal linear prediction to create the differential image

[Height,Width,Depth] = size(I);
if Depth > 1
    I1 = double(rgb2gray(I));
else
    I1 = double(I);
end

I1 = I1 .* (~mask);

img_sx = I1;
img_dx = I1;

% Coefficienti
alfa=zeros(1,p);
for i = 1:p
    alfa(i)=1/p;
end

for r = 1:Height
    
    %Devo contare quanti '1' ci sono nella riga.
    contatore = 0;
    for c_cont = 1:Width
        if(mask(r,c_cont)>=1)
            contatore = contatore + 1;
        end
    end

    % Trovo i coefficienti
    if(contatore>0)
        coeff_sx = linspace(1,0,contatore+2);
        coeff_dx = 1-coeff_sx;
    end
    riga_coeff_sx = zeros(1,Width);
    riga_coeff_dx = zeros(1,Width);
        
    % Predizione
    j=1+1;

    for c = p+1:Width
        if(mask(r,c)>=1)
            temp_sx = 0;
            for i = 1:p
                temp_sx = temp_sx + alfa(i)*img_sx(r,c-i);
            end
            riga_coeff_sx(c) = coeff_sx (j);
            j=j+1;
            img_sx(r,c) = img_sx(r,c) + temp_sx;
        end
    end

    y=contatore+1;

    for c = Width-p:-1:1
        if(mask(r,c)>=1)
            temp_dx = 0;
            for i = 1:p
                temp_dx = temp_dx + alfa(i)*img_dx(r,c+i);
            end
            riga_coeff_dx(c) = coeff_dx (y);
            y=y-1;
            img_dx(r,c) = img_dx(r,c) + temp_dx;
        end
    end

    % Devo applicare i coefficienti
    img_sx(r,:) = img_sx(r,:).*riga_coeff_sx;
    img_dx(r,:) = img_dx(r,:).*riga_coeff_dx;

end

imgOut = img_dx.*mask + img_sx.*mask + I1;




    
    
    
    
    
    
% I = zeros(10,10);
% I = I+10;
% mask = zeros(size(I));
% p=1;    
    
    
    
    
    
    
    
    
    
