function B = autoCorr2DNormalized(A)
% Two-dimensional auto-correlation  NORMALIZED by Svanera.
%   Author(s): it's me!!

Cor = conv2(A, rot90(conj(A),2));

[Height,Width,Depth] = size(A);
[Height_cor,Width_cor,Depth_cor] = size(Cor);

Cor_norm=zeros(size(Cor));

for i=1:Height_cor
    for j=1:Width_cor
        if(i<Height && j<Width)
            Cor_norm(i,j) = Cor(i,j) / (i*j);      %((Height-i)*(Width-j));
        elseif(i>=Height && j<Width)
            Cor_norm(i,j) = Cor(i,j) / (j*(2*Height-i));              %((Height+Height-i)*(Width-j));
        elseif(i<Height && j>=Width)
            Cor_norm(i,j) = Cor(i,j) / (i*(2*Width-j));      %((Height-i)*(Width+Width-j));
        else
            Cor_norm(i,j) = Cor(i,j) / ((2*Height-i)*(2*Width-j));                      %((Height+Height-i)*(Width+Width-j));            
        end
    end    
end

B = Cor_norm;

%surf(Cor_norm,'DisplayName','Cor'),shading interp;figure(gcf);


