function imgOut = inpaintingBN (img,BW)

[Height,Width,Depth] = size(img);

% ------------------------- Filtri -------------------------

h0=[sqrt(2)/2 sqrt(2)/2];
h1=[sqrt(2)/2 -sqrt(2)/2];
g0=[sqrt(2)/2 sqrt(2)/2];
g1=[-sqrt(2)/2 sqrt(2)/2];


%% ------------------------- Maschere-------------------------
 
BW_1_teo = BW(1:2:end,1:2:end);
BW_2_teo = BW_1_teo(1:2:end,1:2:end);
BW_3_teo = BW_2_teo(1:2:end,1:2:end);

BW_1 = espandi(BW_1_teo);
BW_2 = espandi(BW_2_teo);
BW_3 = espandi(BW_3_teo);


%% ------------------------- Trasformata dell'immagine -------------------------

[cA_u_1,cH_u_1,cV_u_1,cD_u_1] = dwt2(img,h0,h1);      %computes the approximation coefficients matrix cA and details coefficients matrices cH, cV, and cD (horizontal, vertical, and diagonal, respectively)
[cA_u_2,cH_u_2,cV_u_2,cD_u_2] = dwt2(cA_u_1,h0,h1);
[cA_u_3,cH_u_3,cV_u_3,cD_u_3] = dwt2(cA_u_2,h0,h1);

cA_u_3_vis = rescale_0_255(cA_u_3);
cH_u_3_vis = rescale_0_255(cH_u_3);
cV_u_3_vis = rescale_0_255(cV_u_3);
cD_u_3_vis = rescale_0_255(cD_u_3);

c_u_3_vis = [cA_u_3_vis cH_u_3_vis ;
        cV_u_3_vis cD_u_3_vis];
    
cH_u_2_vis = rescale_0_255(cH_u_2);
cV_u_2_vis = rescale_0_255(cV_u_2);
cD_u_2_vis = rescale_0_255(cD_u_2);

c_u_2_vis = [c_u_3_vis cH_u_2_vis;
      cV_u_2_vis cD_u_2_vis];

cH_u_1_vis = rescale_0_255(cH_u_1);
cV_u_1_vis = rescale_0_255(cV_u_1);
cD_u_1_vis = rescale_0_255(cD_u_1);

c_u_vis = [c_u_2_vis cH_u_1_vis ; 
      cV_u_1_vis cD_u_1_vis];   

c_u_vis = uint8(c_u_vis);
  
% Colorazione righe e colonne
c_u_vis(Height/2:Height/2+1,:)=0;
c_u_vis(:,Width/2:Width/2+1)=0;
c_u_vis(Height/4:Height/4+1,1:Width/2)=0;
c_u_vis(1:Height/2,Width/4:Width/4+1)=0;
c_u_vis(Height/8:Height/8+1,1:Width/4)=0;
c_u_vis(1:Height/4,Width/8:Width/8+1)=0;

figure;imshow((c_u_vis));    

% Trasformata della maschera
% [cA_m_1,cH_m_1,cV_m_1,cD_m_1] = dwt2(mask,h0,h1);
% [cA_m_2,cH_m_2,cV_m_2,cD_m_2] = dwt2(cA_m_1,h0,h1);
% [cA_m_3,cH_m_3,cV_m_3,cD_m_3] = dwt2(cA_m_2,h0,h1);
% c_m_3 = [cA_m_3 cH_m_3 ;
%         cV_m_3 cD_m_3];
% c_m_2 = [c_m_3 cH_m_2;
%       cV_m_2 cD_m_2];
% c_m = [c_m_2 cH_m_1 ; 
%       cV_m_1 cD_m_1];   
% figure;imshow((c_m),[]); 

%pause; close all;


%% ------------------------- Predizione -------------------------

cA_u_3_Pred = LinPredCoarse(cA_u_3,BW_3);
cH_u_3_Pred = LinPredHorizPdim(cH_u_3,BW_3,2);
cV_u_3_Pred = LinPredVertPdim(cV_u_3,BW_3,2);
cD_u_3_Pred = LinPredDiag(cD_u_3,BW_3);

% c_u_3_Pred = [cA_u_3_Pred cH_u_3_Pred ;
%           cV_u_3_Pred cD_u_3_Pred];
     
cH_u_2_Pred = LinPredHorizPdim(cH_u_2,BW_2,3);
cV_u_2_Pred = LinPredVertPdim(cV_u_2,BW_2,3);
cD_u_2_Pred = LinPredDiag(cD_u_2,BW_2);

% c_u_2_Pred = [c_u_3_Pred cH_u_2_Pred;
%       cV_u_2_Pred cD_u_2_Pred];
 
cH_u_1_Pred = LinPredHorizPdim(cH_u_1,BW_1,4);
cV_u_1_Pred = LinPredVertPdim(cV_u_1,BW_1,4);
cD_u_1_Pred = LinPredDiag(cD_u_1,BW_1);

% c_u_Pred = [c_u_2_Pred cH_u_1_Pred ; 
%        cV_u_1_Pred cD_u_1_Pred]; 
 
% figure, set(gcf,'name','cH_u_3_Pred'); imshow(cH_u_3_Pred,[]);
% figure, set(gcf,'name','cV_u_3_Pred'); imshow(cV_u_3_Pred,[]);
% figure, set(gcf,'name','cD_u_3_Pred'); imshow(cD_u_3_Pred,[]);
%  
% figure, set(gcf,'name','cH_u_2_Pred'); imshow(cH_u_2_Pred,[]);
% figure, set(gcf,'name','cV_u_2_Pred'); imshow(cV_u_2_Pred,[]);
% figure, set(gcf,'name','cD_u_2_Pred'); imshow(cD_u_2_Pred,[]);
%
% figure, set(gcf,'name','cH_u_1_Pred'); imshow(cH_u_1_Pred,[]);
% figure, set(gcf,'name','cV_u_1_Pred'); imshow(cV_u_1_Pred,[]);
% figure, set(gcf,'name','cD_u_1_Pred'); imshow(cD_u_1_Pred,[]);


%% ------------------------- Ricostruzione -------------------------

cA_Ricost_2 = idwt2(cA_u_3_Pred,cH_u_3_Pred,cV_u_3_Pred,cD_u_3_Pred,g0,g1);
cA_Ricost_1 = idwt2(cA_Ricost_2,cH_u_2_Pred,cV_u_2_Pred,cD_u_2_Pred,g0,g1);
ricostr = idwt2(cA_Ricost_1,cH_u_1_Pred,cV_u_1_Pred,cD_u_1_Pred,g0,g1);

ricostr = uint8(ricostr);

imgOut = ricostr;


