function imgOut = inpaintingBN_1_livelli (img,BW)

% ------------------------- Filtri -------------------------

h0=[sqrt(2)/2 sqrt(2)/2];
h1=[sqrt(2)/2 -sqrt(2)/2];
g0=[sqrt(2)/2 sqrt(2)/2];
g1=[-sqrt(2)/2 sqrt(2)/2];


%% ------------------------- Maschere-------------------------
 
BW_1_teo = BW(1:2:end,1:2:end);

BW_1 = espandi(BW_1_teo);


%% ------------------------- Trasformata dell'immagine -------------------------

[cA_u_1,cH_u_1,cV_u_1,cD_u_1] = dwt2(img,h0,h1);      %computes the approximation coefficients matrix cA and details coefficients matrices cH, cV, and cD (horizontal, vertical, and diagonal, respectively)
% c_u = [cA_u_1 cH_u_1 ; 
%       cV_u_1 cD_u_1];   
%figure;imshow((c_u),[]);    

% Trasformata della maschera
% [cA_m_1,cH_m_1,cV_m_1,cD_m_1] = dwt2(mask,h0,h1);
% [cA_m_2,cH_m_2,cV_m_2,cD_m_2] = dwt2(cA_m_1,h0,h1);
% [cA_m_3,cH_m_3,cV_m_3,cD_m_3] = dwt2(cA_m_2,h0,h1);
% c_m_3 = [cA_m_3 cH_m_3 ;
%         cV_m_3 cD_m_3];
% c_m_2 = [c_m_3 cH_m_2;
%       cV_m_2 cD_m_2];
% c_m = [c_m_2 cH_m_1 ; 
%       cV_m_1 cD_m_1];   
% figure;imshow((c_m),[]); 

%pause; close all;


%% ------------------------- Predizione -------------------------

cA_u_1_Pred = LinPredCoarse(cA_u_1,BW_1); 
cH_u_1_Pred = LinPredHorizPdim(cH_u_1,BW_1,5);
cV_u_1_Pred = LinPredVertPdim(cV_u_1,BW_1,5);
cD_u_1_Pred = LinPredDiag(cD_u_1,BW_1); 


% %% -- Codice per salvare le sottobande originali e predette --
% 
% cA_u_1_vis = uint8(rescale_0_255(cA_u_1));
% cH_u_1_vis = uint8(rescale_0_255(cH_u_1));
% cV_u_1_vis = uint8(rescale_0_255(cV_u_1));
% cD_u_1_vis = uint8(rescale_0_255(cD_u_1));
% 
% cA_u_1_Pred_vis = uint8(rescale_0_255(cA_u_1_Pred));
% cH_u_1_Pred_vis = uint8(rescale_0_255(cH_u_1_Pred));
% cV_u_1_Pred_vis = uint8(rescale_0_255(cV_u_1_Pred));
% cD_u_1_Pred_vis = uint8(rescale_0_255(cD_u_1_Pred));
% 
% 
% imwrite(cA_u_1_vis,'cA_u_1.bmp');
% imwrite(cA_u_1_Pred_vis,'cA_u_1_Pred.bmp');
% imwrite(cH_u_1_vis,'cH_u_1.bmp');
% imwrite(cH_u_1_Pred_vis,'cH_u_1_Pred.bmp');
% imwrite(cV_u_1_vis,'cV_u_1.bmp');
% imwrite(cV_u_1_Pred_vis,'cV_u_1_Pred.bmp');
% imwrite(cD_u_1_vis,'cD_u_1.bmp');
% imwrite(cD_u_1_Pred_vis,'cD_u_1_Pred.bmp');


%% ------------------------- Ricostruzione -------------------------

ricostr = idwt2(cA_u_1_Pred,cH_u_1_Pred,cV_u_1_Pred,cD_u_1_Pred,g0,g1);

ricostr = uint8(ricostr);

imgOut = ricostr;


