function imgOut = inpaintingBN_2_livelli (img,BW)

% ------------------------- Filtri -------------------------

h0=[sqrt(2)/2 sqrt(2)/2];
h1=[sqrt(2)/2 -sqrt(2)/2];
g0=[sqrt(2)/2 sqrt(2)/2];
g1=[-sqrt(2)/2 sqrt(2)/2];


%% ------------------------- Maschere-------------------------
 
BW_1_teo = BW(1:2:end,1:2:end);
BW_2_teo = BW_1_teo(1:2:end,1:2:end);

BW_1 = espandi(BW_1_teo);
BW_2 = espandi(BW_2_teo);


%% ------------------------- Trasformata dell'immagine -------------------------

[cA_u_1,cH_u_1,cV_u_1,cD_u_1] = dwt2(img,h0,h1);      %computes the approximation coefficients matrix cA and details coefficients matrices cH, cV, and cD (horizontal, vertical, and diagonal, respectively)
[cA_u_2,cH_u_2,cV_u_2,cD_u_2] = dwt2(cA_u_1,h0,h1);
c_u_2 = [cA_u_2 cH_u_2;
      cV_u_2 cD_u_2];
c_u = [c_u_2 cH_u_1 ; 
      cV_u_1 cD_u_1];   
%figure;imshow((c_u),[]);    

% Trasformata della maschera
% [cA_m_1,cH_m_1,cV_m_1,cD_m_1] = dwt2(mask,h0,h1);
% [cA_m_2,cH_m_2,cV_m_2,cD_m_2] = dwt2(cA_m_1,h0,h1);
% [cA_m_3,cH_m_3,cV_m_3,cD_m_3] = dwt2(cA_m_2,h0,h1);
% c_m_3 = [cA_m_3 cH_m_3 ;
%         cV_m_3 cD_m_3];
% c_m_2 = [c_m_3 cH_m_2;
%       cV_m_2 cD_m_2];
% c_m = [c_m_2 cH_m_1 ; 
%       cV_m_1 cD_m_1];   
% figure;imshow((c_m),[]); 

%pause; close all;


%% ------------------------- Predizione -------------------------

cA_u_2_Pred = LinPredCoarse(cA_u_2,BW_2);
cH_u_2_Pred = LinPredHorizPdim(cH_u_2,BW_2,4);
cV_u_2_Pred = LinPredVertPdim(cV_u_2,BW_2,4);
cD_u_2_Pred = LinPredDiag(cD_u_2,BW_2);

% c_u_2_Pred = [c_u_3_Pred cH_u_2_Pred;
%       cV_u_2_Pred cD_u_2_Pred];
 
cH_u_1_Pred = LinPredHorizPdim(cH_u_1,BW_1,5);
cV_u_1_Pred = LinPredVertPdim(cV_u_1,BW_1,5);
cD_u_1_Pred = LinPredDiag(cD_u_1,BW_1); 

% c_u_Pred = [c_u_2_Pred cH_u_1_Pred ; 
%        cV_u_1_Pred cD_u_1_Pred]; 
 


%% ------------------------- Ricostruzione -------------------------

cA_Ricost_1 = idwt2(cA_u_2_Pred,cH_u_2_Pred,cV_u_2_Pred,cD_u_2_Pred,g0,g1);
ricostr = idwt2(cA_Ricost_1,cH_u_1_Pred,cV_u_1_Pred,cD_u_1_Pred,g0,g1);

ricostr = uint8(ricostr);

imgOut = ricostr;


