function out = psnr (I,K,mask)
% Funzione la quale calcola il PSNR tra l'immagine originale I
% e l'immagine ricostruita R, calcolata solo nei valori nella 
% maschera mask

[Height,Width,Depth] = size(I);

out = 0;
MSE = 0;

if size(I) ~= size(K)
    return;
end

for i=1:Height
    for j=1:Width
        if(mask(i,j)==1)
            temp = (( I(i,j) - K(i,j) )^2);
            MSE = MSE + double(temp);
        end
    end
end

MSE = double(MSE);
area = sum(sum(mask));

if(area~=0)
    MSE = MSE / double(area);
else
    return;
end

if(MSE~=0)
    out = 20*log10( double(max(max(I))) / (sqrt(MSE)) );
else
    return;
end

%MSE 0.1308 area 1950
