function img = LinPredVertPdim(I,mask,p)
% Metodo il quale, data un'image in ingresso, predice (solo) la zona selezionata
% dalla maschera.
% Predizione ORIZZONTALE.
% I = input intensity image
% p = predictor order
% img = output image
% Uses 1st-order optimal linear prediction to create the differential image

[Height,Width,Depth] = size(I);
if Depth > 1
    I1 = double(rgb2gray(I));
else
    I1 = double(I);
end

img = I1;

%Mu = mean2(I1);                     % mean value of the image
%I1 = I1 - Mu;                       % mean removed input image
%R0 = mean2(I1 .* I1);
%R1 = sum(sum(I1(:,2:Width).* I1(:,1:Width-1)))/(Height*(Width-1));
%alfa = R1/R0;

alfa=zeros(1,p);
for i = 1:p
    alfa(i)=1/p;
end

% Inserire il controllo: alfa deve essere di dimensione almeno p

% Implement the Linear Predictor

%pe = zeros(Height,Width);           % array to store prediction errors
%I1 = padarray(I1,[0 1],'symmetric','pre');
for c = 1:Width
    for r = 2:Height
        if(mask(r,c)>=1 && (r-p>0))
            temp = 0;
            for i = 1:p
                temp = temp + alfa(i)*img(r-i,c);
            end
            img(r,c) = temp;              % predicted pixel
        end
    end
end
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
